Subject: bug#24467: 25.1; package

From: [email-masked]
Date: Sat, 24 Sep 2016 22:45:03 -0400

tags 24467 confirmed
severity 24467 minor
quit

Michael Heerdegen <[email-masked]> writes:

> Noam Postavsky <[email-masked]> writes:
>>
>> I put the above as my init.el in a temporary HOME dir, when I run
>> package-list-packages melpa packages are all "available" for me.
>
> Maybe it is different on the first run?

Yes, if I close and reopen Emacs, then I see the "new" packages too.

>
> Hmm, anyway, I found out that with
>
>  (package-initialize)
>  (setq package-archives
>      '(("gnu" . "http://elpa.gnu.org/packages/")
>       ("melpa" . "http://melpa.milkbox.net/packages/")))
>
> in my init file I see the issue.  But with
>
>   (setq package-archives
>         '(("gnu" . "http://elpa.gnu.org/packages/")
>           ("melpa" . "http://melpa.milkbox.net/packages/")))
>   (package-initialize)
>
> it seems to be fixed (i.e. the same expressions just transposed).  With
> other words, `package-archives' seemingly needs to be set before calling
> `package-intialize' (@SK Kim, do you see the same?).

Ah, so the packages are "new" in the sense that they come from archives
added after package-initialize was called.

>
> With the first version, after Emacs startup, `package-archive-contents'
> only includes the "gnu" packages.  With the second version, it seems to
> include "everything" (the list is too long to be printed in reasonable
> time).  That variable is used to decide what packages are new.  That's
> were the problem seems to come from.
>
> I think the behavior is at least "surprising", a pitfall.

Would be nice to avoid it, indeed.